package com.mortals.xhx.module.accept.web;
import com.mortals.framework.annotation.RepeatSubmit;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.model.BaseEntity;
import com.mortals.framework.service.IUser;
import com.mortals.framework.util.DateUtils;
import com.mortals.framework.utils.BeanUtil;
import com.mortals.framework.utils.ReflectUtils;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.accept.model.AcceptQuery;
import com.mortals.xhx.module.accept.model.vo.AcceptPdu;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.accept.model.AcceptEntity;
import com.mortals.xhx.module.accept.service.AcceptService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
import com.mortals.xhx.common.code.*;
/**
*
* 综窗接件信息
*
* @author zxfei
* @date 2024-04-10
*/
@RestController
@RequestMapping("accept")
public class AcceptController extends BaseCRUDJsonBodyMappingController<AcceptService,AcceptEntity,Long> {

    @Autowired
    private ParamService paramService;

    public AcceptController(){
        super.setModuleDesc( "综窗接件信息");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        super.init(model, context);
    }

    @PostMapping({"insert"})
    @UnAuth
    @RepeatSubmit
    public String save(@RequestBody AcceptPdu pdu) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        int code = 1;
        String busiDesc = "新增" + this.getModuleDesc();
        AcceptEntity entity = new AcceptEntity();
        try {
            entity.setApplicantId(pdu.getApplicantId());
            if(StringUtils.isEmpty(pdu.getDateTime())){
                pdu.setDateTime(DateUtils.getCurrStrDateTime());
            }
            entity.setStorageInfo(JSONObject.toJSONString(pdu));
            entity.setCreateUserId(1l);
            entity.setCreateTime(new Date());
            this.saveBefore(entity, model, context);
            this.service.save(entity, context);

            model.put("id", entity.getId());
            code = this.saveAfter(entity, model, context);
            model.put("entity", entity);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", entity);
            this.init(model, context);
            code = this.saveException(entity, model, context, var9);
        }

        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }


    @PostMapping({"getInfo"})
    @UnAuth
    public String getInfo(@RequestBody AcceptPdu pdu) {
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        int code = 1;
        String busiDesc = "获取" + this.getModuleDesc();
        try {
            AcceptEntity entity = this.service.selectOne(new AcceptQuery().applicantId(pdu.getApplicantId()));
            if(entity!=null){
                pdu = JSONObject.parseObject(entity.getStorageInfo(),AcceptPdu.class);
            }
            model.put("entity", pdu);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】 [id:" + entity.getId() + "]");
        } catch (Exception var9) {
            this.doException(this.request, busiDesc, model, var9);
            model.put("entity", pdu);
            this.init(model, context);
        }
        this.init(model, context);
        JSONObject ret = new JSONObject();
        ret.put("code", code);
        ret.put("msg", model.remove("message_info"));
        ret.put("data", model);
        return ret.toJSONString();
    }
}